const {src, dest, series} = require('gulp')

const rename = require('gulp-rename')
const cleanCss = require('gulp-clean-css')
const sass = require('gulp-sass')
const autoprefixer = require('gulp-autoprefixer')
const clean = require('gulp-clean')
const replace = require('gulp-replace')

const bootstrapPackage = require('./node_modules/bootstrap/package')
const package = require('./package')

// Clean dist directory.
function cleanDist() {
    return src('dist/*')
        .pipe(clean())
}

// Build
function build() {
    return src('src/*.scss')
        .pipe(replace('{bootstrapVersion}', bootstrapPackage['version']))
        .pipe(replace('{version}', package['version']))
        .pipe(replace('{author}', package['author']))
        .pipe(replace('{homepage}', package['homepage']))
        .pipe(sass({outputStyle: 'expanded'}))
        .pipe(autoprefixer({cascade: false}))
        .pipe(dest('dist'))
        .pipe(cleanCss())
        .pipe(rename({suffix: '.min'}))
        .pipe(dest('dist'))
}

exports.build = series(cleanDist, build)
